## ydotool 0.1.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(ydotool)

set(CMAKE_CXX_STANDARD 14)
set(PROJECT_VERSION "0.1.5")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_PACKAGE_VERSION_PATCH "5")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Generic Linux command-line automation tool (no X!)")
set(CPACK_PACKAGE_CONTACT "Reimu NotMoe <https://github.com/ReimuNotMoe>")
set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/ReimuNotMoe/ydotool")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE ${CMAKE_PROJECT_HOMEPAGE_URL})
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.14), libstdc++6 (>= 5.2), libuinputplus (>= 0.1.3), libevdevplus (>= 0.1.0)")
set(CPACK_PACKAGE_FILE_NAME ${PROJECT_NAME}_${PROJECT_VERSION}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE})
set(CPACK_DEBIAN_DEBUGINFO_PACKAGE yes)
set(CPACK_DEBIAN_COMPRESSION_TYPE "xz")
set(CPACK_GENERATOR "DEB;RPM;TXZ")
set(CPACK_SOURCE_GENERATOR "DEB;RPM;TXZ")
include(CPack)

include(GNUInstallDirs)

set(SOURCE_FILES_LIBRARY
        CommonIncludes.hpp
        Library/libydotool.cpp Library/libydotool.hpp
        Library/Tool.hpp Library/Tool.cpp
#        Library/Transport.cpp Library/Transport.hpp
        Library/Instance.cpp Library/Instance.hpp
        Library/Utils.cpp Library/Utils.hpp Tools/Tools.hpp
        Tools/MouseMove/MouseMove.hpp Tools/MouseMove/MouseMove.cpp
        Tools/Key/Key.hpp Tools/Key/Key.cpp
        Tools/Click/Click.hpp Tools/Click/Click.cpp
        Tools/Type/Type.hpp Tools/Type/Type.cpp
        Tools/Recorder/Recorder.cpp Tools/Recorder/Recorder.hpp
        )
#        Library/Transports/UnixSocket.cpp Library/Transports/UnixSocket.hpp )

set(SOURCE_FILES_DAEMON
        CommonIncludes.hpp
        Daemon/ydotoold.cpp Daemon/ydotoold.hpp)


set(SOURCE_FILES_CLIENT
        CommonIncludes.hpp
        Client/ydotool.cpp Client/ydotool.hpp)

add_library(ydotool_library SHARED ${SOURCE_FILES_LIBRARY})
set_target_properties(ydotool_library PROPERTIES OUTPUT_NAME ydotool)
add_library(ydotool_library_static STATIC ${SOURCE_FILES_LIBRARY})
set_target_properties(ydotool_library_static PROPERTIES OUTPUT_NAME ydotool)
target_link_libraries(ydotool_library dl boost_program_options uInputPlus evdevPlus)
target_link_libraries(ydotool_library_static dl boost_program_options uInputPlus evdevPlus)

link_libraries(-L.)
add_executable(ydotoold ${SOURCE_FILES_DAEMON})
target_link_libraries(ydotoold ydotool_library dl pthread boost_program_options uInputPlus evdevPlus)

add_executable(ydotool_client ${SOURCE_FILES_CLIENT})
target_link_libraries(ydotool_client ydotool_library boost_program_options pthread uInputPlus evdevPlus)
set_target_properties(ydotool_client PROPERTIES OUTPUT_NAME ydotool)

add_executable(ydotool_client_static ${SOURCE_FILES_CLIENT})
target_link_libraries(ydotool_client_static ydotool_library_static boost_program_options pthread uInputPlus evdevPlus -static)
set_target_properties(ydotool_client_static PROPERTIES OUTPUT_NAME ydotool_static)

#add_library(mousemove SHARED Tools/MouseMove/MouseMove.hpp Tools/MouseMove/MouseMove.cpp)
#target_link_libraries(mousemove ydotool_library boost_program_options uInputPlus evdevPlus)
#
#add_library(key SHARED Tools/Key/Key.hpp Tools/Key/Key.cpp)
#target_link_libraries(key ydotool_library boost_program_options uInputPlus evdevPlus)
#
#add_library(click SHARED Tools/Click/Click.hpp Tools/Click/Click.cpp)
#target_link_libraries(click ydotool_library boost_program_options uInputPlus evdevPlus)
#
#add_library(type SHARED Tools/Type/Type.hpp Tools/Type/Type.cpp)
#target_link_libraries(type ydotool_library boost_program_options uInputPlus evdevPlus)
#
#add_library(recorder SHARED Tools/Recorder/Recorder.cpp Tools/Recorder/Recorder.hpp)
#target_link_libraries(recorder ydotool_library boost_program_options uInputPlus evdevPlus)


install(TARGETS ydotool_library ydotool_library_static DESTINATION lib)
#install(TARGETS mousemove key click type recorder DESTINATION lib/ydotool)
install(TARGETS ydotoold ydotool_client DESTINATION bin)

=== debian/changelog ===
ydotool (0.1.8-2) unstable; urgency=medium

  * Improve ydotoold long description.

 -- Alexandre Viau <aviau@debian.org>  Tue, 11 Feb 2020 17:27:57 -0500

ydotool (0.1.8-1) unstable; urgency=medium

  * Initial release. (Closes: #951138)

 -- Alexandre Viau <aviau@debian.org>  Tue, 11 Feb 2020 17:17:38 -0500

=== debian/control ===
Source: ydotool
Section: utils
Priority: optional
Maintainer: Alexandre Viau <aviau@debian.org>
Build-Depends: debhelper (>=12),
               cmake,
               dh-exec,
               pkg-config,
               libevdevplus-dev,
               libuinputplus-dev,
               libboost-program-options-dev
Standards-Version: 4.5.0
Homepage: https://github.com/ReimuNotMoe/ydotool
Vcs-Git: https://salsa.debian.org/debian/ydotool.git
Vcs-Browser: https://salsa.debian.org/debian/ydotool

Package: ydotool
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Command-line automation tool - cli
 Generic Linux command-line automation tool
 .
 ydotool works differently from xdotool. xdotool
 sends X events directly to X server, while ydotool
 uses the uinput framework of Linux kernel to emulate
 an input device.
 .
 When ydotool runs and creates an virtual input device,
 it will take some time for your graphical environment
 (X11/Wayland) to recognize and enable the virtual
 input device. (Usually done by udev)
 .
 This package contains the command-line utility.

Package: ydotoold
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Command-line automation tool - daemon
 Generic Linux command-line automation tool
 .
 ydotool works differently from xdotool. xdotool
 sends X events directly to X server, while ydotool
 uses the uinput framework of Linux kernel to emulate
 an input device.
 .
 When ydotool runs and creates an virtual input device,
 it will take some time for your graphical environment
 (X11/Wayland) to recognize and enable the virtual
 input device. (Usually done by udev)
 .
 This package contains the daemon.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

PACKAGE=$(shell dh_listpackages)
TMP=$(CURDIR)/debian/$(PACKAGE)

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- ydotool_client_static

## ydotool 1.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(ydotool C)

set(CMAKE_C_STANDARD 99)

# Include GNU install directory module to detect where to install
# files on Linux/Unix systems (e.g., lib vs lib64)
include(GNUInstallDirs)
find_package(PkgConfig)

# Try to get the systemd directory for user units from the package
# and fall back on upstream default without the '/usr' prefix
pkg_check_modules(SYSTEMD systemd)
if (SYSTEMD_FOUND)
    pkg_get_variable(SD_UNITDIR systemd systemduserunitdir)
else()
    set(SD_UNITDIR "lib/systemd/user")
endif()

execute_process(COMMAND git describe --tags --long --always RESULT_VARIABLE RC_GIT_VER OUTPUT_VARIABLE GIT_VERSION)

if (${RC_GIT_VER} EQUAL 0)
    string(STRIP ${GIT_VERSION} GIT_VERSION)
    message("-- Version: " ${GIT_VERSION})
    add_definitions(-DVERSION=\"${GIT_VERSION}\")
endif()



set(SOURCE_FILES_DAEMON Daemon/ydotoold.c)
set(SOURCE_FILES_CLIENT Client/ydotool.c Client/tool_click.c Client/tool_mousemove.c Client/tool_type.c Client/tool_key.c)

add_executable(ydotoold ${SOURCE_FILES_DAEMON})
install(TARGETS ydotoold DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(ydotool ${SOURCE_FILES_CLIENT})
install(TARGETS ydotool DESTINATION ${CMAKE_INSTALL_BINDIR})

add_subdirectory(Daemon)
add_subdirectory(manpage)

=== Daemon/CMakeLists.txt ===
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/ydotool.service.in"
    "${PROJECT_BINARY_DIR}/ydotool.service"
    @ONLY)
install(FILES "${PROJECT_BINARY_DIR}/ydotool.service" DESTINATION ${SD_UNITDIR})

=== manpage/CMakeLists.txt ===
function(man_page section page)
  set(src "${CMAKE_CURRENT_SOURCE_DIR}/${page}.${section}.scd")
  set(bin "${CMAKE_CURRENT_BINARY_DIR}/${page}.${section}")
  add_custom_target(${page}.${section} ALL COMMAND scdoc < ${src} > ${bin})
  install(FILES ${bin} DESTINATION ${CMAKE_INSTALL_MANDIR}/man${section}/)
endfunction(man_page)

man_page(1 ydotool)
man_page(8 ydotoold)

=== debian/changelog ===
ydotool (1.0.4-2~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Andre Paiusco <debian@paiusco.org>  Mon, 15 Sep 2025 20:42:37 +0200

ydotool (1.0.4-2) unstable; urgency=medium

  * d/control: fix breakage with previous ydotoold (Closes: #1110400)
  * d/tests: Add first basic autopkgtests for package
  # d/salsa-cu: Add base gitlabci config

 -- Andre Paiusco <debian@paiusco.org>  Sun, 10 Aug 2025 22:45:48 +0200

ydotool (1.0.4-1) experimental; urgency=medium

  * Change of maintainers (Closes: #1086596).
  * New upstream release (Closes: #1053561).
  * glibc is now dynamically linked (Closes: #1106805)
  * Move license from MIT to AGPL-3.0
  * Update Standard version and Compat version
  * Merge daemon (ydotoold) into ydotool package
  * Add udev rule needed for user service daemon
  * Add DEP12 metadata

 -- Andre Paiusco <debian@paiusco.org>  Sun, 18 May 2025 13:29:10 +0100

ydotool (0.1.8-3) unstable; urgency=medium

  * d/control: Rules-Requires-Root: no.
  * depend on livevdevplus >= 0.1.1-2. (Closes: #959905)
  * d/rules: -DCMAKE_POSITION_INDEPENDENT_CODE=ON.

 -- Alexandre Viau <aviau@debian.org>  Tue, 22 Dec 2020 12:53:31 -0500

=== debian/tests/control ===
Tests: smoke-tests
Depends: @, sudo, shunit2
Restrictions: needs-sudo isolation-machine

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ydotool-$1\.tar\.gz/ \
  https://github.com/ReimuNotMoe/ydotool/tags .*/v?(\d\S+)\.tar\.gz
